class MERRiskReport(PWReportPage):
	def init(self):
		super(MERRiskReport, self).init()
		self.project		      = None
		self.withProjectStamp	  = True
		self.withObjective	      = True
		self.withProjectImage     = True
		self.withActions          = True
		self.withAdditionalTitle= True
		self.withAuthoredBy 	  = True
		self.withCategory   	  = True
		self.withDescription      = True
		self.withDidOccur		  = True
		self.withFlagStatus		  = True
		self.withLessonsLearned   = True
		self.withProbability	  = True
		self.withResponsibleResource = True
		self.withReviewDate		  = None
		self.withNotes		      = None
		self.withItem		      = None	
		self.iterItem		      = None
		self.iterIndex		      = 0
		self.risksSortDescriptors = [NSSortDescriptor.alloc().initWithKey_ascending_("recordingDate", True)]
		return self

	def internalParameterKeys(self):
		return ["risksSortDescriptors"]
		
	def risks(self):
		predicate = NSPredicate.predicateWithFormat_argumentArray_("entity.name = %@ AND isPrivate = FALSE AND (parentActivity.isComplete = FALSE OR parentActivity = nil)", ["Risk"])
		risks = self.project.deepElements().allObjects().filteredArrayUsingPredicate_(predicate)
		return risks.sortedArrayUsingDescriptors_(self.risksSortDescriptors)	

	
	def showObjective(self):
		return self.withObjective and self.project.itemDescription()

	def showRisks(self):
		return 1
	

	def rowClass(self):
		if self.iterIndex%2:
			return "even"

	def listItemClass(self):
		if self.iterIndex == 0:
			return "first"
	
	def dateFormat(self):
		return "medium"

	def mailTo(self):
		if self.iterItem and self.iterItem.email():
			return "mailto:"+self.iterItem.email()

	def navigationItems(self):
		bundle = NSBundle.bundleWithIdentifier_("net.projectwizards.reports.Classic")
		items = []
		if self.showRisks():
			items.append({"href":  "#risks", "title": NSLocalizedStringFromTableInBundle("Risks", None, bundle, "")})
		return items


	def flagToImageMapping(self):
		status = self.iterItem.flagStatus()
		if status == 1:
			image = "FlagGreen.png"
		if status == 2:
			image = "FlagYellow.png"
		if status == 3:
			image = "FlagRed.png"
		return image
		#return "<wbl:Image filename=\""+image+"\" width=15 height=15/>"